package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * The Tag Outbound configuration of class type, must contains class 1, class 2, class 3 and others.
 */
@ApiModel(description = "The Tag Outbound configuration of class type, must contains class 1, class 2, class 3 and others.")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class TagOutItemOpenApiVo   {
  @JsonProperty("classType")
  private Integer classType;

  @JsonProperty("enable")
  private Boolean enable;

  @JsonProperty("dscp")
  private String dscp;

  public TagOutItemOpenApiVo classType(Integer classType) {
    this.classType = classType;
    return this;
  }

  /**
   * Class type should be a value as follows: 1: class 1, 2: class 2, 3: class 3, 0: others.
   * @return classType
  */
  @ApiModelProperty(required = true, value = "Class type should be a value as follows: 1: class 1, 2: class 2, 3: class 3, 0: others.")
  @NotNull


  public Integer getClassType() {
    return classType;
  }

  public void setClassType(Integer classType) {
    this.classType = classType;
  }

  public TagOutItemOpenApiVo enable(Boolean enable) {
    this.enable = enable;
    return this;
  }

  /**
   * The status of Class Type, valid value is true or false.
   * @return enable
  */
  @ApiModelProperty(required = true, value = "The status of Class Type, valid value is true or false.")
  @NotNull


  public Boolean getEnable() {
    return enable;
  }

  public void setEnable(Boolean enable) {
    this.enable = enable;
  }

  public TagOutItemOpenApiVo dscp(String dscp) {
    this.dscp = dscp;
    return this;
  }

  /**
   * The DSCP value selected in the Precedence configuration should be a value as follows: 8: IP precedence 1; 16: IP precedence 2; 24: IP precedence 3; 32: IP precedence 4; 40: IP precedence 5; 48: IP precedence 6; 56: IP precedence 7; 10: AF Class 1 (Low Drop); 12: AF Class 1 (Medium Drop); 14: AF Class 1 (High Drop); 18: AF Class 2 (Low Drop); 20: AF Class 2 (Medium Drop); 22: AF Class 2 (High Drop); 26: AF Class 3 (Low Drop); 28: AF Class 3 (Medium Drop); 30: AF Class 3 (High Drop); 34: AF Class 4 (Low Drop); 36: AF Class 4 (Medium Drop); 38: AF Class 4 (High Drop); 46: EF Class.
   * @return dscp
  */
  @ApiModelProperty(required = true, value = "The DSCP value selected in the Precedence configuration should be a value as follows: 8: IP precedence 1; 16: IP precedence 2; 24: IP precedence 3; 32: IP precedence 4; 40: IP precedence 5; 48: IP precedence 6; 56: IP precedence 7; 10: AF Class 1 (Low Drop); 12: AF Class 1 (Medium Drop); 14: AF Class 1 (High Drop); 18: AF Class 2 (Low Drop); 20: AF Class 2 (Medium Drop); 22: AF Class 2 (High Drop); 26: AF Class 3 (Low Drop); 28: AF Class 3 (Medium Drop); 30: AF Class 3 (High Drop); 34: AF Class 4 (Low Drop); 36: AF Class 4 (Medium Drop); 38: AF Class 4 (High Drop); 46: EF Class.")
  @NotNull


  public String getDscp() {
    return dscp;
  }

  public void setDscp(String dscp) {
    this.dscp = dscp;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TagOutItemOpenApiVo tagOutItemOpenApiVo = (TagOutItemOpenApiVo) o;
    return Objects.equals(this.classType, tagOutItemOpenApiVo.classType) &&
        Objects.equals(this.enable, tagOutItemOpenApiVo.enable) &&
        Objects.equals(this.dscp, tagOutItemOpenApiVo.dscp);
  }

  @Override
  public int hashCode() {
    return Objects.hash(classType, enable, dscp);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TagOutItemOpenApiVo {\n");
    
    sb.append("    classType: ").append(toIndentedString(classType)).append("\n");
    sb.append("    enable: ").append(toIndentedString(enable)).append("\n");
    sb.append("    dscp: ").append(toIndentedString(dscp)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

